.code
InitODBC PROC
LOCAL BufferTMP[1024]:BYTE
LOCAL strFindData:WIN32_FIND_DATA
LOCAL SizeTMP:DWORD

	;Get an ODBC enviroment
	invoke SQLAllocHandle,SQL_HANDLE_ENV,SQL_NULL_HANDLE,ADDR hEnvODBC
	.if ax!=SQL_SUCCESS
		invoke ShowErrorODBC,ADDR idbasededatos,@Line-2,SQL_HANDLE_ENV,hEnvODBC
		jmp InitODBC_EndError
	.endif
	
	;Check if the ODBC Version is upper than 2
	invoke SQLSetEnvAttr,hEnvODBC,SQL_ATTR_ODBC_VERSION,SQL_OV_ODBC3,0
	.if ax!=SQL_SUCCESS	
		invoke ShowErrorODBC,ADDR idbasededatos,@Line-2,SQL_HANDLE_ENV,hEnvODBC
		jmp InitODBC_EndError
	.endif
	
	;Check if exist the database file
	invoke FindFirstFile,ADDR DataBaseFile,ADDR strFindData
	.if eax==INVALID_HANDLE_VALUE
		;If it doesn't exist, we notice it
		mov	boolDataBaseExist,FALSE
		invoke MessageBox,NULL,ADDR txtNoExist,ADDR lblNoExist,MB_ICONINFORMATION
	.else
		;If exist, we close the search
		mov boolDataBaseExist,TRUE
		invoke FindClose,eax
	.endif
	 
	;Get a ODBC connection handle
	invoke SQLAllocHandle,SQL_HANDLE_DBC,hEnvODBC,ADDR hConnODBC
	.if ax!=SQL_SUCCESS
		invoke ShowErrorODBC,ADDR idbasededatos,@Line-2,SQL_HANDLE_DBC,hConnODBC
		jmp InitODBC_EndError
	.endif
	
	;Open the connection. If it wasn't exist the database file also create it
	invoke SQLDriverConnect,hConnODBC,NULL,ADDR ODBCString,sizeof ODBCString,ADDR BufferTMP,1,ADDR SizeTMP,SQL_DRIVER_COMPLETE
	.if ax!=(SQL_SUCCESS or SQL_SUCCESS_WITH_INFO)
		invoke ShowErrorODBC,ADDR idbasededatos,@Line-2,SQL_HANDLE_DBC,hConnODBC
		jmp InitODBC_EndError
	.endif
	
	;if it wasn't exist, recreate database structure and fields
	.if boolDataBaseExist==FALSE
		invoke CreateStructure
	.else
		;If exist, check the estructure, and update if it is necesary
		invoke CheckStructure
		.if eax!=0
			;invoke UpdateStructure
		.endif
	.endif

	Ret
InitODBC_EndError:
	mov BigError, TRUE
	Ret
InitODBC EndP
EndODBC PROC
	
	.if hConnODBC!=0
		invoke	SQLDisconnect,hConnODBC
		invoke	SQLFreeHandle,SQL_HANDLE_DBC,hConnODBC
	.endif
	.if hEnvODBC!=0
		invoke	SQLFreeHandle,SQL_HANDLE_ENV,hEnvODBC
	.endif
	Ret
EndODBC EndP
CreateStructure PROC
LOCAL BufferTMP[8192]:BYTE
LOCAL BufferTMP2[8192]:BYTE
LOCAL IndexTMP:DWORD
LOCAL SizeTMP:DWORD

	;Get an stament for the SQL commands
	invoke SQLAllocHandle,SQL_HANDLE_STMT,hConnODBC,ADDR hStmt_1_ODBC
	.if ax!=SQL_SUCCESS
		invoke ShowErrorODBC,ADDR idbasededatos,@Line-2,SQL_HANDLE_STMT,hStmt_1_ODBC
		jmp CreateStructure_EndError
	.endif
	
;Uncoment for now...
	mov IndexTMP,0
	invoke szLen,ADDR TablesToCreate
	mov SizeTMP, eax
	inc eax
	.while eax!=SizeTMP
		inc IndexTMP
		invoke InString,IndexTMP,ADDR TablesToCreate,ADDR cnstDotAndComma
		push eax
		dec IndexTMP
		sub eax, IndexTMP
		invoke szMid,ADDR TablesToCreate,ADDR BufferTMP,IndexTMP,eax
		pop eax
		mov IndexTMP,eax
	
		;We create the table (the first one must be BackupSQLs in this case)
		;Inside it we save a copy of the tables generators (SQLs)
		invoke SQLExecDirect,hStmt_1_ODBC,ADDR BufferTMP,SQL_NTS
		.if !((ax==SQL_SUCCESS) || (ax==SQL_SUCCESS_WITH_INFO))
			invoke ShowErrorODBC,ADDR idbasededatos,@Line-2,SQL_HANDLE_STMT,hStmt_1_ODBC
			jmp CreateStructure_EndError
		.endif
		;Save the SQL
		invoke wsprintf,ADDR BufferTMP2,ADDR fmtCreateAField,ADDR BufferTMP
		invoke SQLExecDirect,hStmt_1_ODBC,ADDR BufferTMP2,SQL_NTS
		.if !((ax==SQL_SUCCESS) || (ax==SQL_SUCCESS_WITH_INFO))
			invoke ShowErrorODBC,ADDR idbasededatos,@Line-2,SQL_HANDLE_STMT,hStmt_1_ODBC
			jmp CreateStructure_EndError
		.endif
		mov eax, IndexTMP
	.endw	
	
	;Free the stament
	.if hStmt_1_ODBC!=0
		invoke SQLFreeStmt,hStmt_1_ODBC,SQL_UNBIND or SQL_CLOSE
		invoke SQLFreeHandle,SQL_HANDLE_STMT,hStmt_1_ODBC
	.endif
	
	invoke MessageBox,NULL,ADDR txtCreated,ADDR lblNoExist,MB_ICONINFORMATION
	Ret
CreateStructure_EndError:
	mov BigError,TRUE
	Ret
CreateStructure EndP
CheckStructure PROC
LOCAL QueryTMP[1024]:BYTE
LOCAL ResultTMP[1024]:BYTE
LOCAL StringTMP[1024]:BYTE
LOCAL PositionTMP:DWORD

	;Get a stament handl to work with SQLs
	invoke SQLAllocHandle,SQL_HANDLE_STMT,hConnODBC,ADDR hStmt_1_ODBC
	.if ax!=SQL_SUCCESS
		invoke ShowErrorODBC,ADDR idbasededatos,@Line-2,SQL_HANDLE_STMT,hStmt_1_ODBC
		jmp CheckStructure_EndError
	.endif
	
	;invoke SQLSetStmtAttr,hStmt_1_ODBC,SQL_ATTR_CURSOR_TYPE,SQL_CURSOR_DYNAMIC,0

	;Get the name of the first table of the list
	mov GeneratorStringPositionSQL,offset TablesToCreate
	invoke ExtractSQLGeneratorString
	invoke ExtractTableName 
	;Make a SQL to check the existence of thar first table
	invoke wsprintf,ADDR QueryTMP,ADDR fmtSQLQuery_Tables,ADDR TableName
	;Run the SQL
	invoke SQLExecDirect,hStmt_1_ODBC,ADDR QueryTMP,SQL_NTS
	.if !((ax==SQL_SUCCESS) || (ax==SQL_SUCCESS_WITH_INFO))
		invoke ShowErrorODBC,ADDR idbasededatos,@Line-2,SQL_HANDLE_STMT,hStmt_1_ODBC
		jmp CheckStructure_EndError
	.else
		;Check if we have results
		invoke SQLNumResultCols,hStmt_1_ODBC,ADDR NumReturnedColumns
		.if NumReturnedColumns>0
			;If we pass it is because the table exist.

			;Close the cursor
			invoke SQLCloseCursor,hStmt_1_ODBC

			;Now we compare the table generator SQL's with program's
			mov GeneratorStringPositionSQL,offset TablesToCreate
			mov ebx, GeneratorStringPositionSQL
			;The loop will check if the needed tables are created or no
			.while byte ptr [ebx]!=0
				;Read the program SQL
				invoke ExtractSQLGeneratorString
				invoke wsprintf,ADDR QueryTMP,ADDR fmtFieldOfTheTable,ADDR TableName,ADDR cnstSQLS,ADDR SQLGeneratorString
				;Run a SELECT query for check the previous SQL
				invoke SQLExecDirect,hStmt_1_ODBC,ADDR QueryTMP,SQL_NTS
				.if !((ax==SQL_SUCCESS) || (ax==SQL_SUCCESS_WITH_INFO))
					invoke ShowErrorODBC,ADDR idbasededatos,@Line-2,SQL_HANDLE_STMT,hStmt_1_ODBC
					jmp CheckStructure_EndError
				.else
					;This SQLNumResulCols doesn't work alone to check if the string is in the table (??)
					invoke SQLNumResultCols,hStmt_1_ODBC,ADDR NumReturnedColumns
					.if NumReturnedColumns>0
						;We need to check the retrived data 
						invoke SQLBindCol,hStmt_1_ODBC,1,SQL_C_CHAR,ADDR ResultTMP,sizeof ResultTMP,ADDR NumReturnedColumns
						;And compare them
						invoke szLen,ADDR SQLGeneratorString
						invoke szCmpi,ADDR ResultTMP,ADDR SQLGeneratorString,eax
						;If the comparation fails, we go out. We need an update of the structure
						.break.if eax!=0
					.endif
				.endif
				;Close the cursor
				invoke SQLCloseCursor,hStmt_1_ODBC
				mov ebx, GeneratorStringPositionSQL
				mov al, byte ptr [ebx]
			.endw
		.elseif
			;If it doesn't exist the man table, show the ERROR
			invoke MessageBox,NULL,ADDR txtMainTableError,NULL,MB_ICONERROR
			jmp CheckStructure_EndError
		.endif
	.endif
	;If the structure is OK...
	mov eax,TRUE
CheckStructure_Fin:
	push eax
	;Free the stament
	.if hStmt_1_ODBC!=0
		invoke	SQLFreeHandle,SQL_HANDLE_STMT,hStmt_1_ODBC
	.endif
	pop eax
	Ret
CheckStructure_EndError:
	;If the structure is BAD...
	mov eax,FALSE
	jmp CheckStructure_Fin
CheckStructure EndP
ExtractSQLGeneratorString PROC uses ebx
LOCAL IndiceLocal:DWORD
	
	invoke InString,1,GeneratorStringPositionSQL,ADDR cnstDotAndComma
	push eax
	invoke szMid,GeneratorStringPositionSQL,ADDR SQLGeneratorString,0,eax
	pop eax

	add GeneratorStringPositionSQL, eax
	Ret
ExtractSQLGeneratorString EndP
ExtractTableName PROC

	invoke InString,14,ADDR SQLGeneratorString,ADDR cnstEspacio
	sub eax, 14
	push eax
	invoke szMid,ADDR SQLGeneratorString,ADDR TableName,13,eax
	pop eax
	Ret
ExtractTableName EndP
UpdateStructure PROC

	Ret
UpdateStructure EndP
ShowErrorODBC proc Fichero:DWORD,Linea:DWORD,Tipo:DWORD,HandleODBC:DWORD
LOCAL BufferTMP[1024]:BYTE
LOCAL BufferTMP2[1024]:BYTE
LOCAL TipoMsg:DWORD
	
	invoke SQLGetDiagField,Tipo,HandleODBC,1,SQL_DIAG_MESSAGE_TEXT,ADDR BufferTMP,sizeof BufferTMP,ADDR Leidos
	.if ax == SQL_SUCCESS_WITH_INFO
		mov TipoMsg,MB_ICONEXCLAMATION or MB_OK
	.else
		mov TipoMsg,MB_ICONERROR or MB_OK
	.endif
	invoke wsprintf,ADDR BufferTMP2,ADDR fmtShowErrorODBC,Fichero,Linea,ADDR BufferTMP
	invoke MessageBox,NULL,ADDR BufferTMP2,NULL,TipoMsg
	mov eax,1
	RET
ShowErrorODBC EndP
